/* Generated by GOB (v2.0.19)   (do not edit directly) */

#include <glib.h>
#include <glib-object.h>
#ifndef __STUFFKEEPER_DATA_ITEM_SEARCH_H__
#define __STUFFKEEPER_DATA_ITEM_SEARCH_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <glib.h>
#include <glib/gi18n.h>

#include <glib/gstdio.h>

#include "stuffkeeper-data-tag.h"
#include "stuffkeeper-data-item.h"
#include "stuffkeeper-data-schema.h"



typedef enum _SearchType {
    SEARCH_TYPE_NONE = 0,
    SEARCH_TYPE_IS = 1,
    SEARCH_TYPE_IS_NOT = 2,
    SEARCH_TYPE_CONTAINS = 3,
    SEARCH_TYPE_NOT_CONTAINS = 4,
    SEARCH_TYPE_NUM_ITEMS = 5
}SearchType;


typedef enum _SearchFieldType {
    SEARCH_TITLE            = 0,
    SEARCH_FIELD_SCHEMA     = 1,
    SEARCH_FIELD_TAG        = 2,
    SEARCH_FIELD_TITLE      = 3,
    SEARCH_FIELD_VALUE      = 4,
    NUM_SEARCH_FIELD        = 5
}SearchFieldType;

typedef struct _SearchField
{
    int id;
    int field_id;
    SearchFieldType field_type;
    SearchType type;
    char *value;
}SearchField;



/*
 * Type checking and casting macros
 */
#define STUFFKEEPER_TYPE_DATA_ITEM_SEARCH	(stuffkeeper_data_item_search_get_type())
#define STUFFKEEPER_DATA_ITEM_SEARCH(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_item_search_get_type(), StuffkeeperDataItemSearch)
#define STUFFKEEPER_DATA_ITEM_SEARCH_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_item_search_get_type(), StuffkeeperDataItemSearch const)
#define STUFFKEEPER_DATA_ITEM_SEARCH_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), stuffkeeper_data_item_search_get_type(), StuffkeeperDataItemSearchClass)
#define STUFFKEEPER_IS_DATA_ITEM_SEARCH(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), stuffkeeper_data_item_search_get_type ())

#define STUFFKEEPER_DATA_ITEM_SEARCH_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), stuffkeeper_data_item_search_get_type(), StuffkeeperDataItemSearchClass)

/* Private structure type */
typedef struct _StuffkeeperDataItemSearchPrivate StuffkeeperDataItemSearchPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_STUFFKEEPER_DATA_ITEM_SEARCH__
#define __TYPEDEF_STUFFKEEPER_DATA_ITEM_SEARCH__
typedef struct _StuffkeeperDataItemSearch StuffkeeperDataItemSearch;
#endif
struct _StuffkeeperDataItemSearch {
	GObject __parent__;
	/*< private >*/
	StuffkeeperDataItemSearchPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _StuffkeeperDataItemSearchClass StuffkeeperDataItemSearchClass;
struct _StuffkeeperDataItemSearchClass {
	GObjectClass __parent__;
	/*signal*/void (* search_changed) (StuffkeeperDataItemSearch * self, const SearchField * field);
};


/*
 * Public methods
 */
GType	stuffkeeper_data_item_search_get_type	(void) G_GNUC_CONST;
#line 88 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_search_changed	(StuffkeeperDataItemSearch * self,
					const SearchField * field);
#line 100 "stuffkeeper-data-item-search.h"
#line 141 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_set_string	(StuffkeeperDataItemSearch * self,
					int searchtype,
					int fieldtype,
					const gchar * title);
#line 106 "stuffkeeper-data-item-search.h"
#line 187 "stuffkeeper-data-item-search.gob"
GObject * 	stuffkeeper_data_item_search_new_dummy	(void);
#line 109 "stuffkeeper-data-item-search.h"
#line 196 "stuffkeeper-data-item-search.gob"
GObject * 	stuffkeeper_data_item_search_open_from_id	(GObject * skdb,
					gint id);
#line 113 "stuffkeeper-data-item-search.h"
#line 207 "stuffkeeper-data-item-search.gob"
StuffkeeperDataItemSearch * 	stuffkeeper_data_item_search_new	(GObject * skdb);
#line 116 "stuffkeeper-data-item-search.h"
#line 248 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_free_search_field	(SearchField * field);
#line 119 "stuffkeeper-data-item-search.h"
#line 260 "stuffkeeper-data-item-search.gob"
int 	stuffkeeper_data_item_search_match	(StuffkeeperDataItemSearch * self,
					StuffkeeperDataItem * item);
#line 123 "stuffkeeper-data-item-search.h"
#line 376 "stuffkeeper-data-item-search.gob"
GList * 	stuffkeeper_data_item_search_get_search_fields	(StuffkeeperDataItemSearch * self);
#line 126 "stuffkeeper-data-item-search.h"
#line 404 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_edit_search_field	(StuffkeeperDataItemSearch * self,
					SearchField * field);
#line 130 "stuffkeeper-data-item-search.h"
#line 426 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_remove_search_field	(StuffkeeperDataItemSearch * self,
					SearchField * field);
#line 134 "stuffkeeper-data-item-search.h"
#line 442 "stuffkeeper-data-item-search.gob"
SearchField * 	stuffkeeper_data_item_search_new_search_field	(StuffkeeperDataItemSearch * self,
					SearchType searchtype,
					SearchFieldType fieldtype,
					const gchar * value);
#line 140 "stuffkeeper-data-item-search.h"
#line 478 "stuffkeeper-data-item-search.gob"
char * 	stuffkeeper_data_item_search_get_title	(StuffkeeperDataItemSearch * self);
#line 143 "stuffkeeper-data-item-search.h"
#line 492 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_set_title	(StuffkeeperDataItemSearch * self,
					const char * title);
#line 147 "stuffkeeper-data-item-search.h"
#line 504 "stuffkeeper-data-item-search.gob"
int 	stuffkeeper_data_item_search_get_id	(StuffkeeperDataItemSearch * self);
#line 150 "stuffkeeper-data-item-search.h"
#line 511 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_delete_yourself	(StuffkeeperDataItemSearch * self);
#line 153 "stuffkeeper-data-item-search.h"
#line 565 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_style_set	(StuffkeeperDataItemSearch * self,
					GtkStyle * style,
					GtkWidget * wid);
#line 158 "stuffkeeper-data-item-search.h"
#line 601 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_search_title_changed	(StuffkeeperDataItemSearch * self,
					GtkWidget * entry);
#line 162 "stuffkeeper-data-item-search.h"
#line 745 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_add_field	(StuffkeeperDataItemSearch * self,
					GtkWidget * button);
#line 166 "stuffkeeper-data-item-search.h"
#line 762 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_remove_field	(StuffkeeperDataItemSearch * self,
					GtkWidget * button);
#line 170 "stuffkeeper-data-item-search.h"
#line 780 "stuffkeeper-data-item-search.gob"
void 	stuffkeeper_data_item_search_edit_search_gui	(StuffkeeperDataItemSearch * self);
#line 173 "stuffkeeper-data-item-search.h"

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define stuffkeeper_data_item_search_connect__search_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM_SEARCH(__extension__ ({StuffkeeperDataItemSearch *___object = (object); ___object; })),"search_changed",(GCallback) __extension__ ({void (* ___search_changed) (StuffkeeperDataItemSearch * ___fake___self, const SearchField * ___fake___field, gpointer ___data ) = (func); ___search_changed; }), (data))
#define stuffkeeper_data_item_search_connect_after__search_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM_SEARCH(__extension__ ({StuffkeeperDataItemSearch *___object = (object); ___object; })),"search_changed",(GCallback) __extension__ ({void (* ___search_changed) (StuffkeeperDataItemSearch * ___fake___self, const SearchField * ___fake___field, gpointer ___data ) = (func); ___search_changed; }), (data))
#define stuffkeeper_data_item_search_connect_data__search_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM_SEARCH(__extension__ ({StuffkeeperDataItemSearch *___object = (object); ___object; })),"search_changed",(GCallback) __extension__ ({void (* ___search_changed) (StuffkeeperDataItemSearch * ___fake___self, const SearchField * ___fake___field, gpointer ___data ) = (func); ___search_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define stuffkeeper_data_item_search_connect__search_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM_SEARCH(object),"search_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_search_connect_after__search_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM_SEARCH(object),"search_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_search_connect_data__search_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM_SEARCH(object),"search_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
